
package org.ow2.jasmine.monitoring.eos.purgetimer.service;

import java.io.Serializable;

import javax.naming.NamingException;

import org.ow2.jasmine.event.messages.JasmineEventTimer;
import org.ow2.jasmine.monitoring.eos.common.jndilocator.ServiceLocator;
import org.ow2.jasmine.monitoring.eos.purgetimer.service.exchange.ExecuteAction;
import org.ow2.jasmine.monitoring.eos.purgetimer.service.exchange.ResultAction;
import org.ow2.jasmine.monitoring.eventswitch.beans.JasmineEventTimerSLBRemote;



public class PurgeTimerService implements Serializable {

    /**
     *
     */
    private static final long serialVersionUID = -8056979296509798113L;

    private JasmineEventTimerSLBRemote jasmineTimerRemote = null;


    public PurgeTimerService() throws NamingException {
        this.jasmineTimerRemote = (JasmineEventTimerSLBRemote)ServiceLocator.getInstance().getRemoteObject("db-ejb/timer");
    }


    public ResultAction execute(final ExecuteAction action) throws Exception {

        try {

            JasmineEventTimer event = new JasmineEventTimer();

            event.setMaxEntryAge(action.getMaxEntryAge());
            event.setMaxEntryNumber(action.getMaxEntryNumber());
            event.setExecutionStartDate(action.getExecutionStartDate());
            event.setExecutionStartHours(action.getExecutionStartHours());
            event.setExecutionInterval(action.getExecutionInterval());
            event.setExecuteOnAllServers(action.isExecuteOnAllServers());
            event.setImmediateExecution(action.isImmediateExecution());
            event.setDomainName(action.getDomainName());
            event.setServerName(action.getServerName());

            int result = jasmineTimerRemote.configureTimer(event);

            ResultAction executedAction = new ResultAction();
            executedAction.setResult(result);

            return executedAction;

        } catch (Exception e) {
            e.printStackTrace();
            throw e;
        }

    }




}
